ArgumentException Klasse

Definition

Die Ausnahme, die ausgelöst wird, wenn eines der Argumente für eine Methode ungültig ist.The exception that is thrown when one of the arguments provided to a method is not valid.

public ref class ArgumentException : SystemException
[System.Runtime.InteropServices.ComVisible(true)]
[System.Serializable]
public class ArgumentException : SystemException
type ArgumentException = class
    inherit SystemException
    interface ISerializable
Public Class ArgumentException
Inherits SystemException
Vererbung
ArgumentException
Abgeleitet
Attribute
Implementiert

Beispiele

Im folgenden Beispiel wird veranschaulicht, wie ein ArgumentExceptionausgelöst und abgefangen wird.The following example demonstrates how to throw and catch an ArgumentException. Er verwendet argumumtexception. GetType (). Name -Eigenschaft, um den Namen des Ausnahme Objekts anzuzeigen, und verwendet auch Message die-Eigenschaft, um den Text der Ausnahme Meldung anzuzeigen.It uses the ArgumentException.GetType().Name property to display the name of the exception object, and also uses the Message property to display the text of the exception message.

using namespace System;

static int DivideByTwo(int num) 
{
    // If num is an odd number, throw an ArgumentException.
    if ((num & 1) == 1)
        throw gcnew ArgumentException(String::Format("{0} is not an even number", num), 
                                      "num");

    // num is even, return half of its value.
    return num / 2;
}

void main() 
{
    // Define some integers for a division operation.
    array<int>^ values = { 10, 7 };
    for each (int value in values) {
        try {
           Console::WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
        }
        catch (ArgumentException^ e) {
           Console::WriteLine("{0}: {1}", e->GetType()->Name, e->Message);
        }
        Console::WriteLine();
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
using System;

public class Example 
{
    static void Main() 
    {
        // Define some integers for a division operation.
        int[] values = { 10, 7 };
        foreach (var value in values) {
            try {
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
            }
            catch (ArgumentException e) {
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message);
            }
            Console.WriteLine();
        }
    }

    static int DivideByTwo(int num) 
    {
        // If num is an odd number, throw an ArgumentException.
        if ((num & 1) == 1)
            throw new ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num");

        // num is even, return half of its value.
        return num / 2;
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
Public Class Example
    Public Shared Sub Main()
        ' Define some integers for a division operation.
        Dim values() As Integer = { 10, 7 }

        For Each value In values
            Try 
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value))
            Catch e As ArgumentException
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message)
            End Try
            Console.WriteLine()
        Next
    End Sub
    
    Private Shared Function DivideByTwo(ByVal num As Integer) As Integer
        ' If num is an odd number, throw an ArgumentException.
        If (num And 1) = 1 Then
            Throw New ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num")
        End If
        Return num \ 2
    End Function
End Class
' The example displays the following output:
'     10 divided by 2 is 5
'     
'     ArgumentException: 7 is not an even number
'     Parameter name: num

Hinweise

ArgumentExceptionwird ausgelöst, wenn eine Methode aufgerufen wird und mindestens eines der übergebenen Argumente nicht der Parameter Spezifikation der aufgerufenen Methode entspricht.ArgumentException is thrown when a method is invoked and at least one of the passed arguments does not meet the parameter specification of the called method. Die ParamName -Eigenschaft identifiziert das ungültige Argument.The ParamName property identifies the invalid argument.

In den meisten Fällen ArgumentException wird eine von der Common Language Runtime oder einer anderen Klassenbibliothek ausgelöst und weist auf einen Entwickler Fehler hin.Most commonly, an ArgumentException is thrown by the common language runtime or another class library and indicates developer error. Wenn Sie einen ArgumentException aus Ihrem Code auslösen, sollten Sie sicherstellen, dass die Message -Eigenschaft der Ausnahme eine sinnvolle Fehlermeldung enthält, in der das ungültige Argument und der erwartete Wertebereich für das Argument beschrieben werden.If you throw an ArgumentException from your code, you should ensure that the exception's Message property includes a meaningful error message that describes the invalid argument and the expected range of values for the argument.

Die primären abgeleiteten Klassen ArgumentException von ArgumentNullException sind ArgumentOutOfRangeExceptionund.The primary derived classes of ArgumentException are ArgumentNullException and ArgumentOutOfRangeException. Diese abgeleiteten Klassen sollten anstelle von ArgumentExceptionverwendet werden, außer in Situationen, in denen keine der abgeleiteten Klassen zulässig ist.These derived classes should be used instead of ArgumentException, except in situations where neither of the derived classes is acceptable. Ausnahmen sollten z. b. von ausgelöst werden:For example, exceptions should be thrown by:

  • ArgumentNullExceptionWenn null an eine Methode, die Sie nicht akzeptiert, als gültiges Argument verwendet wird.ArgumentNullException whenever null is passed to a method that does not accept it as a valid argument.

  • ArgumentOutOfRangeExceptionWenn der Wert eines Arguments außerhalb des zulässigen Wertebereichs liegt, Wenn z DateTime. b. der Wert "46" während der Erstellung eines als Monats Argument angezeigt wird.ArgumentOutOfRangeException when the value of an argument is outside the range of acceptable values; for example, when the value "46" is passed as the month argument during the creation of a DateTime.

Wenn der Methoden aufrufkein Argument hat oder wenn der Fehler nicht die Argumente selbst einschließt, InvalidOperationException sollte verwendet werden.If the method call does not have any argument or if the failure does not involve the arguments themselves, then InvalidOperationException should be used.

ArgumentExceptionverwendet das HRESULT-COR_E_ARGUMENT, das den Wert 0x80070057 aufweist.ArgumentException uses the HRESULT COR_E_ARGUMENT, which has the value 0x80070057.

Eine Liste der anfänglichen Eigenschaftswerte für eine Instanz von ArgumentException, finden Sie unter den ArgumentException Konstruktoren.For a list of initial property values for an instance of ArgumentException, see the ArgumentException constructors.

Konstruktoren

ArgumentException()

Initialisiert eine neue Instanz der ArgumentException-Klasse.Initializes a new instance of the ArgumentException class.

ArgumentException(SerializationInfo, StreamingContext)

Initialisiert eine neue Instanz der ArgumentException-Klasse mit serialisierten Daten.Initializes a new instance of the ArgumentException class with serialized data.

ArgumentException(String)

Initialisiert eine neue Instanz der ArgumentException-Klasse mit einer angegebenen Fehlermeldung.Initializes a new instance of the ArgumentException class with a specified error message.

ArgumentException(String, Exception)

Initialisiert eine neue Instanz der ArgumentException-Klasse mit einer angegebenen Fehlermeldung und einem Verweis auf die innere Ausnahme, die diese Ausnahme ausgelöst hat.Initializes a new instance of the ArgumentException class with a specified error message and a reference to the inner exception that is the cause of this exception.

ArgumentException(String, String)

Initialisiert eine neue Instanz der ArgumentException-Klasse mit einer angegebenen Fehlermeldung und dem Namen des Parameters, der die Ausnahme auslöst.Initializes a new instance of the ArgumentException class with a specified error message and the name of the parameter that causes this exception.

ArgumentException(String, String, Exception)

Initialisiert eine neue Instanz der ArgumentException-Klasse mit einer angegebenen Fehlermeldung, dem Parameternamen und einem Verweis auf die innere Ausnahme, die diese Ausnahme verursacht hat.Initializes a new instance of the ArgumentException class with a specified error message, the parameter name, and a reference to the inner exception that is the cause of this exception.

Eigenschaften

Data

Ruft eine Auflistung von Schlüssel-Wert-Paaren ab, die zusätzliche benutzerdefinierte Informationen über die Ausnahme bereitstellen.Gets a collection of key/value pairs that provide additional user-defined information about the exception.

(Geerbt von Exception)
HelpLink

Ruft einen Link zur Hilfedatei ab, die dieser Ausnahme zugeordnet ist, oder legt einen Link fest.Gets or sets a link to the help file associated with this exception.

(Geerbt von Exception)
HResult

Ruft HRESULT ab oder legt HRESULT fest. Dies ist ein codierter Wert, der einer bestimmten Ausnahme zugeordnet ist.Gets or sets HRESULT, a coded numerical value that is assigned to a specific exception.

(Geerbt von Exception)
InnerException

Ruft die Exception-Instanz ab, die die aktuelle Ausnahme verursacht hat.Gets the Exception instance that caused the current exception.

(Geerbt von Exception)
Message

Ruft die Fehlermeldung und den Parameternamen oder nur die Fehlermeldung ab, wenn kein Parametername festgelegt ist.Gets the error message and the parameter name, or only the error message if no parameter name is set.

ParamName

Ruft den Namen des Parameters ab, der diese Ausnahme auslöst.Gets the name of the parameter that causes this exception.

Source

Gibt den Namen der Anwendung oder des Objekts zurück, die bzw. das den Fehler verursacht hat, oder legt diesen fest.Gets or sets the name of the application or the object that causes the error.

(Geerbt von Exception)
StackTrace

Ruft eine Zeichenfolgendarstellung der unmittelbaren Frames in der Aufrufliste ab.Gets a string representation of the immediate frames on the call stack.

(Geerbt von Exception)
TargetSite

Ruft die Methode ab, die die aktuelle Ausnahme auslöst.Gets the method that throws the current exception.

(Geerbt von Exception)

Methoden

Equals(Object)

Bestimmt, ob das angegebene Objekt mit dem aktuellen Objekt identisch ist.Determines whether the specified object is equal to the current object.

(Geerbt von Object)
GetBaseException()

Gibt beim Überschreiben in einer abgeleiteten Klasse eine Exception zurück, die die ursprüngliche Ursache für eine oder mehrere nachfolgende Ausnahmen ist.When overridden in a derived class, returns the Exception that is the root cause of one or more subsequent exceptions.

(Geerbt von Exception)
GetHashCode()

Fungiert als Standardhashfunktion.Serves as the default hash function.

(Geerbt von Object)
GetObjectData(SerializationInfo, StreamingContext)

Legt das SerializationInfo-Objekt mit dem Parameternamen und zusätzlichen Informationen zur Ausnahme fest.Sets the SerializationInfo object with the parameter name and additional exception information.

GetType()

Ruft den Laufzeittyp der aktuellen Instanz ab.Gets the runtime type of the current instance.

(Geerbt von Exception)
MemberwiseClone()

Erstellt eine flache Kopie des aktuellen Object.Creates a shallow copy of the current Object.

(Geerbt von Object)
ToString()

Erstellt eine Zeichenfolgendarstellung der aktuellen Ausnahme und gibt diese zurück.Creates and returns a string representation of the current exception.

(Geerbt von Exception)

Ereignisse

SerializeObjectState

Tritt auf, wenn eine Ausnahme serialisiert wird, um ein Ausnahmezustandsobjekt mit serialisierten Daten über die Ausnahme zu erstellen.Occurs when an exception is serialized to create an exception state object that contains serialized data about the exception.

(Geerbt von Exception)

Gilt für:

Siehe auch